-- Frontpacker
-- Specialization for Frontpacker
--
-- @Author	FIAT80-90DT
-- @Date	12.02.12


Frontpacker = {};

function Frontpacker.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

function Frontpacker:load(xmlFile)
	self.groundReferenceNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.groundReferenceNode#index"));
	self.groundReferenceThreshold = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.groundReferenceNode#threshold"), 0.2);
end;

function Frontpacker:delete()
end;

function Frontpacker:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Frontpacker:keyEvent(unicode, sym, modifier, isDown)
end;

function Frontpacker:update(dt)
end;

function Frontpacker:updateTick(dt)
	if self:getIsActive() then
		if self.isServer then
			local x,y,z = getWorldTranslation(self.groundReferenceNode); 
			local terrainHeight = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z);
			if terrainHeight+self.groundReferenceThreshold >= y then
				local cuttingAreasSend = {};
				for k,cuttingArea in pairs(self.cuttingAreas) do
					if self:getIsAreaActive(cuttingArea) then
						local x,y,z = getWorldTranslation(cuttingArea.start);
						local x1,y1,z1 = getWorldTranslation(cuttingArea.width);
						local x2,y2,z2 = getWorldTranslation(cuttingArea.height);
						table.insert(cuttingAreasSend, {x,z,x1,z1,x2,z2});
					end;
				end;
				if (table.getn(cuttingAreasSend) > 0) then
					SprayerAreaEvent.runLocally(cuttingAreasSend);
					g_server:broadcastEvent(SprayerAreaEvent:new(cuttingAreasSend));
				end;
			end;
		end;
	end;
end;

function Frontpacker:draw()
end;

function Frontpacker:onAttach(attacherVehicle)
end;

function Frontpacker:onDetach()
end;